/*
* This confidential and proprietary software may be used only as
* authorized by licensing agreement from Multicamera.Systems LLC
* Copyright (C) 2017-2020 Multicamera.Systems LLC - All Rights Reserved
* You should have received a copy of the our license with this file.
* If not, please write to: info@multicamera.systems
*
* This code and information is provided "AS IS" without warranty of any kind,
* either expressed or implied, including but not limited to the implied
* warranties of merchantability and/or fitness for a particular purpose.
*/

#pragma once
#include "stream_parameters.h"
#include "streamer_plugin.h"



class GPUVideoStream
{
public:
    virtual ~GPUVideoStream() = 0;

public:
    virtual bool Init(STREAM_CONFIGURATION *pStreamConfiguration) = 0;
    virtual void DeInit(void) = 0;

    virtual bool SetParameters(OUTPUT_STREAM_PARAMETERS *pStreamParameters) = 0;

    virtual STREAM_PROCESS_RESULT Process(FRAME_DESC *pInputFrameDesc) = 0;

    virtual void ReleaseOutput(FRAME_DESC *pOutput) = 0;

    virtual void WaitForIdle(int32_t pause_time_ms = -1) = 0;
};



#define GPU_STREAMER_FLAG__ONE_GPU_PER_POOL     1



uint32_t CreateStreamerGPU(PFN_LOG pfnLog, uint64_t ullFlags, void *pKey, uint32_t uiKeySize);
void DestroyStreamerGPU(void);
GPUVideoStream * CreateStreamGPU(void);
bool CheckParametersGPU(INPUT_STREAM_PARAMETERS *pInputStreamParameters, OUTPUT_STREAM_PARAMETERS *pOutputStreamParameters);

#define CreateStreamerGPUFuncName "CreateStreamerGPU"
#define DestroyStreamerGPUFuncName "DestroyStreamerGPU"
#define CreateStreamGPUFuncName "CreateStreamGPU"
#define CheckParametersGPUFuncName "CheckParametersGPU"

typedef uint32_t(*PFN_CREATE_STREAMER_GPU)(PFN_LOG pfnLog, uint64_t ullFlags, void *pKey, uint32_t uiKeySize);
typedef void(*PFN_DESTROY_STREAMER_GPU)(void);
typedef GPUVideoStream*(*PFN_CREATE_STREAM_GPU)(void);
typedef bool(*PFN_CHECK_PARAMETERS_GPU)(INPUT_STREAM_PARAMETERS *pInputStreamParameters, OUTPUT_STREAM_PARAMETERS *pOutputStreamParameters);

